	PROCESSOR 6502
	INCLUDE "VCS.H"

XPOSP0	EQU	$80
XPOSP1	EQU	$81
SWCHA0	EQU	$82

	SEG	ROM
	ORG	$F800

START	LDA	#$02
	STA	VSYNC
	LDA	#64
	STA	XPOSP0
	LDA	#120
	STA	XPOSP1
START2	STA	WSYNC
	STA	WSYNC
	LDA	#$00
	LDY	#36*76/64+1
	STA	WSYNC
	STY	TIM64T
	STA	VSYNC

FIRST	LDA	XPOSP0
	STA	GRP0
	SEC
	STA	WSYNC
WAIT1	SBC	#15
	BCS	WAIT1
	AND	#$0F
	TAY
	LDA	HMTAB,Y
	STA	HMP0
	STA	RESP0
	STA	WSYNC

	LDA	XPOSP1
	STA	GRP1
	SEC
	STA	WSYNC
WAIT4	SBC	#15
	BCS	WAIT4
	AND	#$0F
	TAY
	LDA	HMTAB,Y
	STA	HMP1
	STA	RESP1
	STA	WSYNC
	STA	HMOVE

WAIT2	STA	WSYNC
	LDA	INTIM
	BNE	WAIT2

	LDY	#191
	STY	COLUP0
	STY	COLUP1
	LDX	#64

KERN	STA	WSYNC
	STX	GRP0
	STX	GRP1
	STY	PF0
	STY	PF1
	STY	PF2
	STY	COLUPF
	STX	COLUP0
	STX	COLUP1
	INX
	DEY
	BNE	KERN

	LDA	#30*76/64+1
	STA	WSYNC
	STA	TIM64T
	STY	COLUPF
	STY	COLUP0
	STY	COLUP1

	LDA	SWCHA
	LDY	SWCHA0
	STA	SWCHA0
	CPY	#$FF
	BNE	WAIT3
	TAY
	LDA	XPOSP0
	ASL	SWCHA0
	BCS	JOY7
	CLC
	ADC	#1
JOY7	ASL	SWCHA0
	BCS	JOY6
	SEC
	SBC	#1
JOY6	ASL	SWCHA0
	BCS	JOY5
	CLC
	ADC	#8
JOY5	ASL	SWCHA0
	BCS	JOY4
	SEC
	SBC	#8
JOY4	STA	XPOSP0
	LDA	XPOSP1
	ASL	SWCHA0
	BCS	JOY3
	CLC
	ADC	#1
JOY3	ASL	SWCHA0
	BCS	JOY2
	SEC
	SBC	#1
JOY2	ASL	SWCHA0
	BCS	JOY1
	CLC
	ADC	#8
JOY1	ASL	SWCHA0
	BCS	JOY0
	SEC
	SBC	#8
JOY0	STA	XPOSP1
	STY	SWCHA0

WAIT3	STA	WSYNC
	LDA	INTIM
	BNE	WAIT3
	LDA	#$02
	STA	WSYNC
	STA	VSYNC

	JMP	START2

HMTAB	HEX	807060504030201000F0E0D0C0B0A090

	ORG	$FFF8
	DC.B	"TEST"
	DC.W	START
	HEX	EB99	